using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.BLL
{
    /// <summary>
	/// 导入电话表
	/// </summary>
	public partial class T_Vis_Telphone
    {
        private readonly DAL.T_Vis_Telphone dal = new DAL.T_Vis_Telphone();
        public T_Vis_Telphone()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_TelID)
        {
            return dal.Exists(F_TelID);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Vis_Telphone model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Vis_Telphone model)
        {
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_TelID)
        {

            return dal.Delete(F_TelID);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string F_TelIDlist)
        {
            return dal.DeleteList(F_TelIDlist);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Vis_Telphone GetModel(int F_TelID)
        {

            return dal.GetModel(F_TelID);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Vis_Telphone> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Vis_Telphone> DataTableToList(DataTable dt)
        {
            List<Model.T_Vis_Telphone> modelList = new List<Model.T_Vis_Telphone>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                Model.T_Vis_Telphone model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }

        #endregion  BasicMethod
        #region  ExtensionMethod
        /// <summary>
        /// 分配更新
        /// </summary>
        /// <returns></returns>
        public bool UpdateFP(int telid, int fpid, int zxid, string zxname, string fpname)
        {
            return dal.UpdateFP(telid, fpid, zxid, zxname, fpname);
        }

        /// <summary>
        /// 呼叫更新
        /// </summary>
        /// <returns></returns>
        public bool UpdateHJ(int telid, int uid, string uname, int resid, string res)
        {
            return dal.UpdateHJ(telid, uid, uname, resid, res);
        }

        /// <summary>
        /// 回访更新
        /// </summary>
        /// <returns></returns>
        public bool UpdateHF(int telid, bool isvis, bool isres, int resid, string res, int uid, string uname,
            string tscore, string rscore, string rings, string wholes, string totals, string remark,
            string visresult, string visinfo, string visis, int qid, string ques)
        {
            return dal.UpdateHF(telid, isvis, isres, resid, res, uid, uname,
                tscore, rscore, rings, wholes, totals, remark, visresult, visinfo, visis,qid,ques);
        }
        public bool UpdateBZ(int telid, string tscore)
        {
            return dal.UpdateBZ(telid, tscore);
        }

        public DataSet GetListDQ(string strWhere)
        {
            return dal.GetListDQ(strWhere);
        }
        public DataSet GetListDQYX(string strWhere)
        {
            return dal.GetListDQYX(strWhere);
        }
        public DataSet GetListDQQ(string strWhere)
        {
            return dal.GetListDQQ(strWhere);
        }
        public DataSet GetListDMDF(string strWhere)
        {
            return dal.GetListDMDF(strWhere);
        }

        public DataSet GetListGW(string strWhere)
        {
            return dal.GetListGW(strWhere);
        }
        public DataSet GetListGWYX(string strWhere)
        {
            return dal.GetListGWYX(strWhere);
        }
        public DataSet GetListBZ(string strWhere)
        {
            return dal.GetListBZ(strWhere);
        }
        public DataSet GetListBZYX(string strWhere)
        {
            return dal.GetListBZYX(strWhere);
        }
        public DataSet GetListExpt(string strWhere)
        {
            return dal.GetListExpt(strWhere);
        }
        /// <summary>
        /// 根据文件删除
        /// </summary>
        public bool DeleteListByFileID(string FileID)
        {
            return dal.DeleteListByFileID(FileID);
        }
        #endregion  ExtensionMethod
    }
}
